# -*- coding: utf-8 -*-
from setuphelpers import *
import os
import json


def update_package():
    proxies = {}
    if isfile(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini")):
        proxywapt = inifile_readstring(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini"), "global", "http_proxy")
        if proxywapt:
            proxies = {"http": proxywapt, "https": proxywapt}

    currentpath = os.path.dirname(os.path.realpath(__file__))

    url_api = "https://api.github.com/repos/paintdotnet/release/releases"

    json_load = json.loads(wgets(url_api, proxies=proxies))

    found = False
    for releases in json_load:
        if found:
            break
        for download in releases["assets"]:
            if download["browser_download_url"].endswith(".winmsi.%s.zip" % control.architecture):
                url_dl = download["browser_download_url"]
                binary = url_dl.split("/")[-1]
                found = True
                break

    realversion = binary.replace("paint.net.", "").replace(".winmsi.%s.zip" % control.architecture, "")

    """
    I list all the msi file of the package and test the msi version
    if the version returned by the msi does not correspond to the previous one, I delete the file
    >>>
    """

    allmsi = glob.glob("*.msi")
    for msi in allmsi:
        vers = get_msi_properties(msi)["ProductVersion"]
        if vers != realversion:
            remove_file(msi)

    if not glob.glob("*.msi"):

        if not isdir(user_desktop()):
            mkdirs(user_desktop())

        """I download the file if it does not exist >>>"""
        wget(url_dl, "paintnet.zip", proxies=proxies)

        """Unzip file >>>"""
        unzip("paintnet.zip", ".")

        """Delete zip >>>"""
        remove_file("paintnet.zip")

        """Copy msi file in wapt package >>>"""
        msipaint = glob.glob("*.msi")[0]

    """I write the version in the control file >>>"""

    control.version = get_msi_properties(glob.glob("*.msi")[0])["ProductVersion"] + "-0"
    control.save_control_to_wapt()
